%ext kdr

#################################
#Change data files		#
#################################

%patchfile $1CB20 egahead.kdr 	#New graphics
%patchfile $2308E STORY.KDR	#New story
%patchfile $29C46 MAPDICT.CK7	#Neutralize MAPDICT
%patchfile $1FA50 MAPHEAD.CK7	#New maps
%patchfile $1FC46 KeenD.tli	#New tile properties
%patchfile $22880 AUDIOHED.AUD	#Audio header
%patchfile $2A042 MAPDICT.CK7	#Audio dictionary


#################################
#Map stuff			#
#################################

#Tiles used in DONE sign:
%patch $4B59 $59     #Tile that when under level icon triggers DONE sign
%patch $4B53 $00 $00 #Clears 1,1 and 2,1 of level icon block
%patch $4B75 $50 $00 #1,1
%patch $4B82 $7A $00 #2,1
%patch $4B67 $58 $00 #2,2


#################################
#Ending story			#
#################################

#Adjustments
%patch $596C $EF $07 #Text read from (2nd window)
%patch $59A6 $B9 $08 #Text read from (3rd window)
%patch $591C $20 $00 #Window width (30 chars)
%patch $595B $20 $00 #Window width (30 chars)
%patch $5995 $20 $00 #Window width (30 chars)

%patch $24128 "As the gigantic elf slowly" $0A
              "collapses into a swirl of" $0A
              "snowflakes, Keen picks up the" $0A
              "shattered remains of an" $0A
              "ornament and muses on one of the" $0A
              "strangest battles he has yet" $0A
              "endured. Wearily he looks to" $0A
              "where Santa is held prisoner." $0A $0A

%patch $2420C "But Santa is gone!" $0A $0A

              "All that remains is a note" $0A
              " scribbled hastily in coal" $0A
              "dust..." $0A $00

%patch $2425F "'Thanks.'" $0A $0A

               "'Oh, and I know when you are" $0A
               "sleeping, I know when you're" $0A
               "awake...'" $0A $0A

               "Keen immediately feels a" $0A
               "familiar sleepy feeling..." $0A $0A

               "And wakes up in his room, in" $0A
               "his bed. Christmas is saved yet" $0A
               "again!" $0A $00

%patch $24329 "Over a healthy breakfast, (the" $0A
              "president having banned all" $0A
              "candy after choking on a" $0A
              "pretzel.) Keen rushes to unwrap" $0A
              "his presents. And what does he" $0A
              "find under the tree?" $0A $0A

%patch $243D2 "'THE (UN)OFFICIAL Keen 7-9" $0A
              "TRILOGY! This isn't even out in" $0A
              "stores yet! Best christmas ever!'" $0A $0A

              "Merry Christmas to you, whatever" $0A
              "time of year you're playing!" $0A $00


#################################
#Texts				#
#################################

%patch $24115 "Bombs in level!" $00

#Paused (Needs fixing for level names)
%patch $4529 $61 $06
%patch $240D1 "PAUSED" $00

#Load level (Needs fixing for level names)
%patch $4573 $68 $06 #When loading saved game
%patch $5DB5 $68 $06 #When loading level
%patch $240D8 "Loading" $00

#Can't defeat window: (Uses old start screen space!)
%patch $6A60 $0F $00 #Window height (6 chars)
%patch $6A64 $1C $00 #Window width (26 chars)
%patch $6A75 $27 $52 #Text read from:

%patch $28C97 "The door refuses to open"	$0A $0A

              "A mocking voice says:"		$0A
              "'Nice try kiddo! But" $0A
              "nothing can harm me except" $0A
              "my specially built bomb" $0A
              "baubles scattered across" $0A
              "the land! And I'm- wait..." $0A $0A

              "I shouldn't have told you that...'" $0A $00


#################################
#Patch a new start screen	#
#################################

#Screen:
%patchfile $124B1 "KDREAMS.DAT"	#Screen code
%patchfile $32AD0 "KDREAMS.TXT"	#Sceen text

#The 'Ready press a key text:
%patch $13852 $18 $00 #V position, lines
%patch $13856 $1A $00 #V position, lines
%patch $1384B $AB     #Color
%patch $1384E $87 $51 #Text loc
%patch $28BF7 "   Ready: Press a key!   " $00


#################################
#Level names patch		#
#################################

#Set pointers to level names:
%patch $23E48 $5A $05 $66 $05 $72 $05 $80 $05 $8E $05 $9A $05 $AA $05 $BC $05
              $CD $05 $DF $05 $F1 $05 $FB $05 $0B $06 $1A $06 $53 $06 $2A $06
              $3C $06 $4D $06

#Level name:
%patch $23FCA "Pseudotopia" $00
%patch $23FD6 "Xmas Forest" $00
%patch $23FE2 "The Igloo" $00
%patch $23FF0 "Sledding Hill" $00
              "Cake Canyon" $00
              " Cookie Cliffs " $00
              "Gingerbread House" $00
              "Ice Skating Pond" $00
              "Winter Wonderland" $00
              "Midnight Clearing" $00
              "Coal Mine" $00
              "Santa's Cottage" $00
              "Peach Pie Pass" $00
              "Crystal Caverns" $00
              "Bad Elf's Chamber" $00
              "Bad Elf's Castle" $00
              "Title" $00
              "Hidden Hills" $00

%patch $24571 "You didn't make it past"
%patch $24589 "Try again"
%patch $24593 "Exit to Pseudotopia" $00




#########################################
#Enemy sprite patches			#
#########################################


#################################
#Pea -> Nap cookie		#
#################################

#Pea spawns using spare wilted flower frames
%patch $9191  $E6 $17 #Wilted flower 5&6

#Change wilted flower to be useful enemy
%patch $25272 $04 $18		#Goto 6
%patch $25290 $46 $1B		#Spawn cookie
%patch $25266 $00 $00 $00 $00	#Remove behavior from
%patch $25284 $00 $00 $00 $00	#Frames so don't 'unwilt'
%patch $25256 $59 $01 $59 $01	#Change anims and speeds
%patch $25260 $40 $01
%patch $25274 $5A $01 $5A $01
%patch $2527E $14 $00


#################################
#PeaPod -> Tank			#
#################################

#Use three animations with four frames to walk
%patch $25D18 $62 $01 $5F $01
%patch $25D36 $63 $01 $60 $01
%patch $25D54 $64 $01 $61 $01
%patch $25D72 $63 $01 $60 $01 #This is a repat of #2

#Make Peapod a rolling tank
%patch $25D90 $5D $01 $5B $01	#Change anims
%patch $25DAE $5E $01 $5C $01
%patch $25D9A $05 $00		#Double anim speed
%patch $25DB8 $05 $00
%patch $25D9C $40 $00		#Havle walking speed (Smoother roll)
%patch $25DBA $40 $00
%patch $25DCA $20 $23		#Change to 2 frames

#Peapod spit aniamtions
%patch $25E08 $66 $01 $65 $01
%patch $25E26 $66 $01 $65 $01

#Set cache start less four (Not needed for tank or pea)
%patch $23E8E $59 $01		#Pea and Peapod cache start

#Change spitting conditions
%patch $92E6 $0E $FF $90 $90 #Condition 1: Spit in any direction
%patch $92F0 $18 $00 $7D     #Condition 2: Spit FAR more often
%patch $92F5 $7C $3E $04 $7D #Condition 3: Produce a max of 10 peas per pod


#################################
#Wilted flower -> Iceblock	#
#################################

#Vanish after 4th frame: (Frees two frames at $25260)
%patch $25254 $00 $00

#Change animation speed
%patch $251E8 $22 $00
%patch $25206 $22 $00
%patch $25224 $12 $00
%patch $25242 $12 $00


#################################
#Carrot -> Reindeer		#
#################################

#Change 4:4-frame run to 4:2 (1-2-1-2)
%patch $255F2 $05 $01 $07 $01
%patch $25610 $06 $01 $08 $01
%patch $2562E $05 $01 $07 $01
%patch $2564C $06 $01 $08 $01
%patch $2566A $09 $01 $0A $01 #(Alter Jump to fit)

#Slow animation speed
%patch $255FC $0A $00
%patch $2561A $0A $00
%patch $25638 $0A $00
%patch $25656 $0A $00

#Increase running speed
%patch $255FE $F0
%patch $2561C $F0
%patch $2563A $F0
%patch $25658 $F0


#################################
#Tater trooper -> Eskimo	#
#################################

#Reduce walking to two frames: (Frees two actions at $257D0)
%patch $257B2 $08 $1D       	#Walk 2 (Goto 1)

#Change animations to fit new bitspace:
%patch $25778 $1F $01 $1A $01 	#Tater walk
%patch $25796 $20 $01 $1B $01 	#Tater walk
%patch $257F0 $21 $01 $1C $01   #Tater stab
%patch $2580E $22 $01 $1D $01	#Tater stab
%patch $2582C $23 $01 $1E $01	#Tater stab

#Shrink cache:
%patch $23E82 $1A $01


#################################
#Star (Grape)			#
#################################

#Add extra animation frame for rising star:
%patch $2573C $19 $01 $19 $01
%patch $25746 $1E $00		#Animation speed

#Expand cache:
%patch $23EAC $19 $01		#Grape cache end


#################################
#Chips -> candle		#
#################################

#CANDLE BUG: Gets stuck in tunnels 2 tiles high.

#Slow down the candle's hopping movement
%patch $25890 $14
%patch $258AE $14
%patch $258CC $14
%patch $258EA $14

#When candle 'charges' it just slides on the ground:
%patch $2591A $8E $1E



#################################
#Broccoli -> penguin		#
#################################

#Change walking frame:
%patch $2548A $F2 $00 $FA $00

#Slow down animation:
%patch $2543A $0E $00
%patch $25458 $0E $00
%patch $25476 $0E $00
%patch $25494 $0E $00

#Change running speed to compensate:
%patch $2543C $F0 $00
%patch $2545A $F0 $00
%patch $25478 $F0 $00
%patch $25496 $F0 $00

#Dash ahead when slapping
%patch $254B4 $60 $00
%patch $254D2 $60 $00
%patch $254F0 $60 $00
%patch $2550E $40 $00
%patch $2552C $C0 $FF
%patch $2554A $C0 $FF
%patch $25568 $C0 $FF

#Change slap animations
%patch $254A8 $F4 $00 $FC $00
%patch $254C6 $F5 $00 $FD $00
%patch $254E4 $F6 $00 $FE $00
%patch $25502 $F7 $00 $FF $00
%patch $25520 $F8 $00 $00 $01
%patch $2553E $F4 $00 $FC $00
%patch $2555C $F5 $00 $FD $00


#################################
#Melon -> snowman		#
#################################

#Snowballs use Keen's snowball anim
%patch $25AC0 $3E $01 $3D $01
%patch $25ADE $3E $01 $3D $01

#Snowman has extra throwing frame, slow throwing speed
%patch $25A2A $3B $01 $3C $01
%patch $25A16 $C0 $00       #Animation speed
%patch $25A52 $0A $00       #Animation speed
%patch $25A52 $0A $00       #Animation speed


#################################
#Apple -> elf			#
#################################

#Apple has only 2 walking frames
%patch $25C08 $5E $21 #Walk 2


%end
